/*
 * appble_central.h
 *
 *  Created on: 13-Apr-2020
 *      Author: prompt
 */

#ifndef MAIN_APPBLE_CENTRAL_H_
#define MAIN_APPBLE_CENTRAL_H_
#include <stdint.h>

#define APP_BLE_TIMER_INTERVAL	1000		//1sec

#define APPBLE_READ_TIME_INTERVAL	5000	//5sec
#define APPBLE_WRITE_TIME_INTERVAL	10000	//10sec

#define APPBLE_READ_REQ_TIMEOUT		(APPBLE_READ_TIME_INTERVAL/APP_BLE_TIMER_INTERVAL)
#define APPBLE_WRITE_REQ_TIMEOUT	(APPBLE_WRITE_TIME_INTERVAL/APP_BLE_TIMER_INTERVAL)



#define BLE_CONFIG_CHR		1
#define BLE_ACTIVITY_CHR	2
#define BLE_BATTERY_CHR		3

typedef enum {
	eAppBleStartEvent,
	eAppBleConnectEvent,
	eAppBleDisconnectEvent,
	eAppBleCommSecuredEvent,
	eAppBleReadEvent,
	eAppBleWriteEvent,
	eAppBleReadCompleteEvent,
	eAppBleWriteCompleteEvent,
	eAppBleNotificationRxEvent,
	eAppBleStopEvent,
} eAppBleEvents;

typedef struct{

	eAppBleEvents events;
	void * pvData;
}AppBleEventStruct;


typedef struct{
	uint16_t conn_handle;
	bool isConnectedFlag;
	bool isComSecuredFlag;
	uint8_t ledblink_cntr;
	uint8_t buffer[128];
	uint8_t bufferlen;
}AppBleDataStruct;

typedef struct {
	int status;
	uint8_t data[128];
	uint8_t datalen;
}AppBleRxPacket;


uint16_t calculate_crc16(uint8_t * , uint32_t );
void ble_app_main(void);
int blecent_stop(void);

int check_svcs_and_chrs(uint16_t );
int read_ble(uint16_t , uint8_t );
int write_ble(uint16_t , uint8_t , uint8_t * , uint16_t );
int subscribe_ble(uint16_t , uint8_t , uint8_t * , uint16_t );
int disconnect_ble(uint16_t );
bool SendEventToAppBleTask(AppBleEventStruct * );


#endif /* MAIN_APPBLE_CENTRAL_H_ */
